<script>
    import { line } from "d3";
    import {
        curveLinear,
        curveStep,
        curveStepAfter,
        curveStepBefore,
        curveNatural,
    } from "d3";
    import { parameter_name } from "../../svelte_stores/catalog_and_info_store.js";

    export let plot_element;
    export let data;
    export let xScale;
    export let yScale;
    export let subplot;

    const curve_types = {
        undefined: curveLinear,
        linear: curveLinear,
        step: curveStep,
        step_after: curveStepAfter,
        step_before: curveStepBefore,
        natural: curveNatural,
    };

    const calculateAverage = function (array) {
        var total = 0;
        var count = 0;

        array.forEach(function (item, index) {
            if (!isNaN(item)) {
                total += item;
                count++;
            }
        });
        if (count > 0) {
            return total / count;
        } else {
            return 0;
        }
    };

    let offset = 0;
    let multiplier = 1;
    let time_offset_sec = 0;
    $: multiplier = plot_element.data_transforms.parameter_multiplier;
    $: offset = plot_element.data_transforms.parameter_offset;
    $: time_offset_sec = plot_element.data_transforms.time_offset_sec
        ? plot_element.data_transforms.time_offset_sec
        : 0;
    let offset_remove_mean = 0;
    $: {
        if (plot_element.data_transforms.parameter_offset_remove_mean) {
            offset_remove_mean = calculateAverage(
                data.datalist.map(
                    (d) => d[parameter_name(plot_element, "parameter")],
                ),
            );
        } else {
            offset_remove_mean = 0;
        }
    }
    $: lineFunction = function (
        data,
        xScale,
        yScale,
        parameter,
        multiplier,
        offset,
        offset_remove_mean,
    ) {
        if (subplot?.scale == "log10") {
            data.datalist = data.datalist.map((d) => {
                if (d[plot_element.data.baseline_parameter] <= 0) {
                    d[plot_element.data.baseline_parameter] = 1e-30;
                }
                return d;
            });
        }
        return line()
            .curve(curve_types[plot_element.plot_options.curve_type])
            .defined((d) => !isNaN(d[parameter]))
            .x((d) =>
                xScale(new Date(d.time.getTime() + time_offset_sec * 1000)),
            )
            .y((d) =>
                yScale(
                    (d[parameter] - offset_remove_mean) * multiplier + offset,
                ),
            )(data.datalist);
    };
</script>

<path
    d={lineFunction(
        data,
        xScale,
        yScale,
        parameter_name(plot_element, "parameter"),
        multiplier,
        offset,
        offset_remove_mean,
    )}
    stroke={plot_element.plot_options["stroke"]}
    stroke-width={plot_element.plot_options["stroke-width"]}
    stroke-opacity={plot_element.plot_options["stroke-opacity"]}
    stroke-linecap="round"
    fill="none">
    <title
        >{plot_element.title} [{plot_element.data.dataset} / {plot_element.data
            .parameter}]</title>
</path>

<style>
</style>
